$! MAKE_SHR_AND_DEMOS.COM
$! based on MAKE_ALL_VMS.COM
$! 11-NOV-1996, David Mathog, Biology Division, Caltech
$! 31-MAR-1997, ", modified for version 0.86
$! 22-JAN-1998, ", modified for version 0.88
$!
$! overall build procedure for FORMS library
$!
$ type sys$input

Warning, if you do not have write access to SYS$SHARE stop this
procedure NOW and modify it.  Many of these .COM require that
XPM_SHR.EXE and XFORMS_SHR.EXE both be in SYS$SHARE.

$ define invms 'F$ENVIRONMENT("DEFAULT")
$!
$ moveone: SUBROUTINE
$ write sys$output "''P1' -> ''P2'"
$ copy 'P1' 'P2'
$ EXIT
$ ENDSUBROUTINE
$!
$ write sys$output "Copying VMS specific files to target directories"
$!
$ call moveone forms.h   [-.FORMS]
$ call moveone local.h   [-.FORMS]
$ call moveone missingfct.c [-.FORMS]
$ call moveone xpmp.h    [-.XPM-3_4G.LIB]
$ call moveone global_psects.opt [-]
$ call moveone last_xforms.opt [-]
$!
$!
$!
$ cc/standard=ansi89/prefix=all upward_opt.c
$ link upward_opt.obj
$ uuu:=$invms:upward_opt
$!
$! in some versions there may be compiler warnings, none significant, so keep
$! going
$!
$ on warning then continue
$ set def [-]
$ goto skipped
$!
$! build the xpm part first, it will leave XPM.OLB in the present
$! directory.
$!
$ write sys$output "Starting to build XPM pieces"
$ set def [-.xpm-3_4g.lib]
$ @invms:make_xpm_vms
$ set def [-.-]
$!
$! build the forms part next, it will leave XFORMS.OLB in the present
$! directory
$!
$ write sys$output "Starting to build FORMS pieces"
$ set def [.forms]
$ @invms:make_forms_vms
$ set def [-]
$!
$! build the shared libraries
$!
$ skipped:
$ write sys$output "Starting to build XPM shared library"
$ @invms:MAKE_OPT_FROM_OLB xpm.olb X11  XPMDATATYPES,XPMCOLORKEYS
$ link/share=[]xpm_shr.exe xpm.opt/opt
$ write sys$output "Moving XPM_SHR to SYS$SHARE"
$ copy xpm_shr.exe sys$share
$ set file/prot=w:re sys$share:xpm_shr.exe
$!
$ write sys$output "Starting to build XFORMS shared library"
$ create xpm2.opt
$ open/append ofil xpm2.opt
$ write ofil "sys$share:xpm_shr.exe/share"
$ search/out=ofil/match=nor global_psects.opt "this string is not in the file"
$ close ofil
$ @invms:MAKE_OPT_FROM_OLB xforms.olb GL,X11 "" xpm2.opt
$!
$! make the upwardly compatible version
$!
$ rename xforms.opt xforms_raw.opt
$ uuu last_xforms.opt xforms_raw.opt xforms.opt 1 1088
$!
$ write sys$output "Ignore any following messages about DATA vs PROCEDURE"
$ link/share=xforms_shr.exe xforms.opt/opt
$!
$ write sys$output "Moving XFORMS_SHR to SYS$SHARE"
$ copy xforms_shr.exe sys$share
$ set file/prot=w:re sys$share:xforms_shr.exe
$!
$!
$ write sys$output "Starting to build DEMOS"
$ set def [.demos]
$ @invms:make_demos_vms
$ set def [-]
$!
$ write sys$output "Starting to build FDESIGN"
$ set def [.design]
$ @invms:make_design_vms
$ set def [-]
$!
$ write sys$output "Starting to build FD2PS"
$ set def [.fd2ps]
$ @invms:make_fd2ps_vms
$ set def [-]
$!
$ type sys$Input 

Xforms build completed.

Before you try to run any of the demos or design, or any programs that you
link to the shareable libraries, you need to do: 

  $ define xpm_shr     wherever:xpm_shr.exe
  $ define xforms_shr  wherever:xforms_shr.exe

If the shared could not be placed into sys$share.

Also, some of the demos assume that "Program_name" is a valid command,
so either define a bunch of symbols, or define DCL$PATH to include the
demos directory.

$! that's it
